diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index 2587ef7..bcae700 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -32,6 +32,7 @@
 #include "executor/nodeHashjoin.h"
 #include "executor/nodeIndexonlyscan.h"
 #include "executor/nodeIndexscan.h"
+#include "executor/nodeIndirectIndexscan.h"
 #include "executor/nodeLimit.h"
 #include "executor/nodeLockRows.h"
 #include "executor/nodeMaterial.h"
@@ -170,6 +171,10 @@ ExecReScan(PlanState *node)
 			ExecReScanIndexScan((IndexScanState *) node);
 			break;
 
+		case T_IndirectIndexScanState:
+			ExecReScanIndirectIndexScan((IndirectIndexScanState *) node);
+			break;
+
 		case T_IndexOnlyScanState:
 			ExecReScanIndexOnlyScan((IndexOnlyScanState *) node);
 			break;
@@ -300,6 +305,10 @@ ExecMarkPos(PlanState *node)
 			ExecIndexMarkPos((IndexScanState *) node);
 			break;
 
+		case T_IndirectIndexScanState:
+			ExecIndirectIndexMarkPos((IndirectIndexScanState *) node);
+			break;
+
 		case T_IndexOnlyScanState:
 			ExecIndexOnlyMarkPos((IndexOnlyScanState *) node);
 			break;
@@ -349,6 +358,9 @@ ExecRestrPos(PlanState *node)
 			ExecIndexRestrPos((IndexScanState *) node);
 			break;
 
+		case T_IndirectIndexScanState:
+			ExecIndirectIndexRestrPos((IndirectIndexScanState *) node);
+
 		case T_IndexOnlyScanState:
 			ExecIndexOnlyRestrPos((IndexOnlyScanState *) node);
 			break;
@@ -393,6 +405,7 @@ ExecSupportsMarkRestore(Path *pathnode)
 	switch (pathnode->pathtype)
 	{
 		case T_IndexScan:
+		case T_IndirectIndexScan:
 		case T_IndexOnlyScan:
 		case T_Material:
 		case T_Sort:
@@ -491,6 +504,11 @@ ExecSupportsBackwardScan(Plan *node)
 			return IndexSupportsBackwardScan(((IndexScan *) node)->indexid) &&
 				TargetListSupportsBackwardScan(node->targetlist);
 
+		case T_IndirectIndexScan:
+			/* FIXME this is expected to work, but is untested */
+			return IndexSupportsBackwardScan(((IndirectIndexScan *) node)->indexid) &&
+				TargetListSupportsBackwardScan(node->targetlist);
+
 		case T_IndexOnlyScan:
 			return IndexSupportsBackwardScan(((IndexOnlyScan *) node)->indexid) &&
 				TargetListSupportsBackwardScan(node->targetlist);
@@ -537,8 +555,8 @@ TargetListSupportsBackwardScan(List *targetlist)
 }
 
 /*
- * An IndexScan or IndexOnlyScan node supports backward scan only if the
- * index's AM does.
+ * An IndexScan, IndirectIndexScan or IndexOnlyScan node supports backward scan
+ * only if the index's AM does.
  */
 static bool
 IndexSupportsBackwardScan(Oid indexid)
diff --git a/src/backend/executor/execIndexing.c b/src/backend/executor/execIndexing.c
index 009c1b7..302fc60 100644
--- a/src/backend/executor/execIndexing.c
+++ b/src/backend/executor/execIndexing.c
@@ -273,7 +273,8 @@ ExecInsertIndexTuples(TupleTableSlot *slot,
 					  EState *estate,
 					  bool noDupErr,
 					  bool *specConflict,
-					  List *arbiterIndexes)
+					  List *arbiterIndexes,
+					  Bitmapset *unchangedAttrs)
 {
 	List	   *result = NIL;
 	ResultRelInfo *resultRelInfo;
@@ -285,6 +286,7 @@ ExecInsertIndexTuples(TupleTableSlot *slot,
 	ExprContext *econtext;
 	Datum		values[INDEX_MAX_KEYS];
 	bool		isnull[INDEX_MAX_KEYS];
+	Datum		pkeyValues[INDEX_MAX_KEYS];
 
 	/*
 	 * Get information from the result relation info structure.
@@ -348,6 +350,27 @@ ExecInsertIndexTuples(TupleTableSlot *slot,
 		}
 
 		/*
+		 * For indirect indexes, verify whether the indexed attributes have
+		 * changed; if they have not, skip the insertion.
+		 */
+		if (indexInfo->ii_IsIndirect)
+		{
+			int		j;
+			bool	may_skip_insertion = true;
+
+			for (j = 0; j < indexInfo->ii_NumIndexAttrs; j++)
+			{
+				if (bms_is_member(indexInfo->ii_KeyAttrNumbers[j], unchangedAttrs))
+					continue;
+				may_skip_insertion = false;
+			}
+
+			/* may skip insertion if no indexed attribute changed value */
+			if (may_skip_insertion)
+				continue;
+		}
+
+		/*
 		 * FormIndexDatum fills in its values and isnull parameters with the
 		 * appropriate values for the column(s) of the index.
 		 */
@@ -357,6 +380,11 @@ ExecInsertIndexTuples(TupleTableSlot *slot,
 					   values,
 					   isnull);
 
+		/* If this is the primary key, save the values for later */
+		if (i == 0)
+			/* XXX probably need datumCopy here instead */
+			memcpy(pkeyValues, values, sizeof(Datum) * INDEX_MAX_KEYS);
+
 		/* Check whether to apply noDupErr to this index */
 		applyNoDupErr = noDupErr &&
 			(arbiterIndexes == NIL ||
@@ -389,6 +417,7 @@ ExecInsertIndexTuples(TupleTableSlot *slot,
 			index_insert(indexRelation, /* index relation */
 						 values,	/* array of index Datums */
 						 isnull,	/* null flags */
+						 pkeyValues,	/* values of primary key */
 						 tupleid,		/* tid of heap tuple */
 						 heapRelation,	/* heap relation */
 						 checkUnique);	/* type of uniqueness check to do */
diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index 554244f..9df9160 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -93,6 +93,7 @@
 #include "executor/nodeHashjoin.h"
 #include "executor/nodeIndexonlyscan.h"
 #include "executor/nodeIndexscan.h"
+#include "executor/nodeIndirectIndexscan.h"
 #include "executor/nodeLimit.h"
 #include "executor/nodeLockRows.h"
 #include "executor/nodeMaterial.h"
@@ -203,6 +204,11 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 													 estate, eflags);
 			break;
 
+		case T_IndirectIndexScan:
+			result = (PlanState *) ExecInitIndirectIndexScan((IndirectIndexScan *) node,
+															 estate, eflags);
+			break;
+
 		case T_IndexOnlyScan:
 			result = (PlanState *) ExecInitIndexOnlyScan((IndexOnlyScan *) node,
 														 estate, eflags);
@@ -427,6 +433,10 @@ ExecProcNode(PlanState *node)
 			result = ExecIndexScan((IndexScanState *) node);
 			break;
 
+		case T_IndirectIndexScanState:
+			result = ExecIndirectIndexScan((IndirectIndexScanState *) node);
+			break;
+
 		case T_IndexOnlyScanState:
 			result = ExecIndexOnlyScan((IndexOnlyScanState *) node);
 			break;
@@ -677,6 +687,10 @@ ExecEndNode(PlanState *node)
 			ExecEndIndexScan((IndexScanState *) node);
 			break;
 
+		case T_IndirectIndexScanState:
+			ExecEndIndirectIndexScan((IndirectIndexScanState *) node);
+			break;
+
 		case T_IndexOnlyScanState:
 			ExecEndIndexOnlyScan((IndexOnlyScanState *) node);
 			break;
diff --git a/src/backend/executor/nodeIndirectIndexscan.c b/src/backend/executor/nodeIndirectIndexscan.c
new file mode 100644
index 0000000..d8ecd19
--- /dev/null
+++ b/src/backend/executor/nodeIndirectIndexscan.c
@@ -0,0 +1,488 @@
+/*-------------------------------------------------------------------------
+ *
+ * nodeIndirectIndexscan.c
+ *	  Routines to support indirect index scans
+ *
+ * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/executor/nodeIndirectIndexscan.c
+ *
+ *-------------------------------------------------------------------------
+ */
+/*
+ * INTERFACE ROUTINES
+ *		ExecIndirectIndexScan		scans an index
+ *		IndirectIndexNext			retrieve next tuple
+ *		ExecInitIndirectIndexScan	creates and initializes state info.
+ *		ExecReScanIndirectIndexScan	rescans the indexed relation.
+ *		ExecEndIndirectIndexScan	releases all storage.
+ *		ExecIndirectIndexMarkPos	marks scan position.
+ *		ExecIndirectIndexRestrPos	restores scan position.
+ */
+#include "postgres.h"
+
+#include "access/relscan.h"
+#include "access/visibilitymap.h"
+#include "executor/execdebug.h"
+#include "executor/nodeIndirectIndexscan.h"
+#include "executor/nodeIndexscan.h"
+#include "storage/bufmgr.h"
+#include "storage/predicate.h"
+#include "utils/lsyscache.h"
+#include "utils/memutils.h"
+#include "utils/rel.h"
+
+
+/* ----------------------------------------------------------------
+ *		IndirectIndexNext
+ *
+ *		Retrieve a tuple from the IndirectIndexScan node's index.
+ * ----------------------------------------------------------------
+ */
+static TupleTableSlot *
+IndirectIndexNext(IndirectIndexScanState *node)
+{
+	EState	   *estate;
+	ScanDirection direction;
+	TupleTableSlot *slot;
+
+	/*
+	 * extract necessary information from index scan node
+	 */
+	estate = node->ss.ps.state;
+	direction = estate->es_direction;
+	/* flip direction if this is an overall backward scan */
+	if (ScanDirectionIsBackward(((IndirectIndexScan *) node->ss.ps.plan)->indexorderdir))
+	{
+		if (ScanDirectionIsForward(direction))
+			direction = BackwardScanDirection;
+		else if (ScanDirectionIsBackward(direction))
+			direction = ForwardScanDirection;
+	}
+	//econtext = node->ss.ps.ps_ExprContext;
+	slot = node->ss.ss_ScanTupleSlot;
+
+	/*----------
+	 * OK, now that we have what we need, fetch the next tuple.
+	 *
+	 * if we don't have a current indirect tuple:
+	 *     obtain tuple from indirect index into slot
+	 *     if no tuple is obtained, return "we're done"
+	 *     apply rescan on PK, set tuple as scankeys
+	 * obtain tuple from PK
+	 * if no tuple is obtained:
+	 *     clear the indirect slot
+	 *     start over
+	 * return tuple
+	 *----------
+	 */
+	for (;;)
+	{
+		HeapTuple	pktuple;
+
+		/*
+		 * If we haven't read a tuple from the indirect index, do so now and
+		 * install it as scan keys into the primary key scan.
+		 */
+		if (!node->iiss_HaveIndirectTuple)
+		{
+			ScanKeyData pkkeys[INDEX_MAX_KEYS];
+			Datum	pkvalues[INDEX_MAX_KEYS];
+			int		nkeys = node->iiss_PKRelationDesc->rd_index->indnatts;
+			bool	isDone;
+			int		i;
+
+			/*
+			 * Obtain one tuple from the indirect index.  If there are no more
+			 * tuples in the indirect index, then the scan is done.
+			 */
+			index_getnext_pkey(node->iiss_IndScanDesc, direction, pkvalues, &isDone);
+			if (isDone)
+				return ExecClearTuple(slot);	/* no more tuples */
+
+			node->iiss_HaveIndirectTuple = true;
+
+			/* Install scan keys, and get the primary key scan started */
+			for (i = 0; i < nkeys; i++)
+			{
+				ScanKeyInit(&pkkeys[i],
+							i + 1,
+							BTEqualStrategyNumber,
+							node->iiss_EqualFuncs[i],
+							pkvalues[i]);
+			}
+
+			index_rescan(node->iiss_PKScanDesc, pkkeys, nkeys,
+						 NULL, 0);
+		}
+
+		/*
+		 * By now, we have a valid tuple from the indirect index and need to
+		 * read (more?) tuples from the PK to return.
+		 */
+		pktuple = index_getnext(node->iiss_PKScanDesc, ForwardScanDirection);
+		if (pktuple == NULL)
+		{
+			/*
+			 * If no tuples are obtained from the PK for the current tuple,
+			 * start over making sure that the indirect scan will advance.
+			 */
+			node->iiss_HaveIndirectTuple = false;
+			continue;
+		}
+
+		// FIXME here we apply ExecQual(), perhaps
+
+		return ExecStoreTuple(pktuple, slot, InvalidBuffer, false);
+	}
+
+	return ExecClearTuple(slot);
+}
+
+/*
+ * IndirectIndexRecheck -- access method routine to recheck a tuple in
+ * EvalPlanQual
+ */
+static bool
+IndirectIndexRecheck(IndirectIndexScanState *node, TupleTableSlot *slot)
+{
+	elog(ERROR, "EvalPlanQual recheck is not supported in indirect index scans");
+	return false;			/* keep compiler quiet */
+}
+
+TupleTableSlot *
+ExecIndirectIndexScan(IndirectIndexScanState *node)
+{
+	/*
+	 * If we have runtime keys and they've not already been set up, do it now.
+	 */
+	if (node->iiss_NumRuntimeKeys != 0 && !node->iiss_RuntimeKeysReady)
+		ExecReScan((PlanState *) node);
+
+	Assert(node->iiss_NumOrderByKeys == 0);	/* FIXME and test */
+	return ExecScan(&node->ss,
+					(ExecScanAccessMtd) IndirectIndexNext,
+					(ExecScanRecheckMtd) IndirectIndexRecheck);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecReScanIndirectIndexScan(node)
+ *
+ *		Recalculates the values of any scan keys whose value depends on
+ *		information known at runtime, then rescans the indexed relation.
+ *
+ *		Updating the scan key was formerly done separately in
+ *		ExecUpdateIndexScanKeys.  Integrating it into ReScan makes
+ *		rescans of indices and relations/general streams more uniform.
+ * ----------------------------------------------------------------
+ */
+void
+ExecReScanIndirectIndexScan(IndirectIndexScanState *node)
+{
+	/*
+	 * If we are doing runtime key calculations (ie, any of the index key
+	 * values weren't simple Consts), compute the new key values.  But first,
+	 * reset the context so we don't leak memory as each outer tuple is
+	 * scanned.  Note this assumes that we will recalculate *all* runtime keys
+	 * on each call.
+	 */
+	if (node->iiss_NumRuntimeKeys != 0)
+	{
+		ExprContext *econtext = node->iiss_RuntimeContext;
+
+		ResetExprContext(econtext);
+		ExecIndexEvalRuntimeKeys(econtext,
+								 node->iiss_RuntimeKeys,
+								 node->iiss_NumRuntimeKeys);
+	}
+	node->iiss_RuntimeKeysReady = true;
+
+	/* XXX We don't support reordering of results */
+
+	/* reset index scan */
+	Assert(node->iiss_NumOrderByKeys == 0);	/* FIXME and test */
+	index_rescan(node->iiss_IndScanDesc,
+				 node->iiss_ScanKeys, node->iiss_NumScanKeys,
+				 node->iiss_OrderByKeys, node->iiss_NumOrderByKeys);
+
+	ExecScanReScan(&node->ss);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecEndIndirectIndexScan
+ * ----------------------------------------------------------------
+ */
+void
+ExecEndIndirectIndexScan(IndirectIndexScanState *node)
+{
+	Relation	indexRelationDesc;
+	Relation	pkRelationDesc;
+	IndexScanDesc indexScanDesc;
+	IndexScanDesc pkScanDesc;
+	Relation	relation;
+
+	/*
+	 * extract information from the node
+	 */
+	indexRelationDesc = node->iiss_IndRelationDesc;
+	pkRelationDesc = node->iiss_PKRelationDesc;
+	indexScanDesc = node->iiss_IndScanDesc;
+	pkScanDesc = node->iiss_PKScanDesc;
+	relation = node->ss.ss_currentRelation;
+
+	/* clear out tuple table slots */
+	ExecClearTuple(node->ss.ps.ps_ResultTupleSlot);
+	ExecClearTuple(node->ss.ss_ScanTupleSlot);
+
+	/* close the index relations (no-op if we didn't open them) */
+	if (indexScanDesc)
+		index_endscan(indexScanDesc);
+	if (pkScanDesc)
+		index_endscan(pkScanDesc);
+	if (indexRelationDesc)
+		index_close(indexRelationDesc, NoLock);
+	if (pkRelationDesc)
+		index_close(pkRelationDesc, NoLock);
+
+	/* close the heap relation */
+	ExecCloseScanRelation(relation);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecIndirectIndexMarkPos
+ * ----------------------------------------------------------------
+ */
+void
+ExecIndirectIndexMarkPos(IndirectIndexScanState *node)
+{
+	index_markpos(node->iiss_IndScanDesc);
+	node->iiss_HaveIndirectTuple = false;	/* necessary? */
+}
+
+/* ----------------------------------------------------------------
+ *		ExecIndirectIndexRestrPos
+ * ----------------------------------------------------------------
+ */
+void
+ExecIndirectIndexRestrPos(IndirectIndexScanState *node)
+{
+	index_restrpos(node->iiss_IndScanDesc);
+	node->iiss_HaveIndirectTuple = false;	/* necessary? */
+}
+
+/* ----------------------------------------------------------------
+ *		ExecInitIndirectIndexScan
+ *
+ *		Initializes the index scan's state information, creates
+ *		scan keys, and opens the base and index relations.
+ *
+ *		Note: indirect index scans have 3 sets of state information
+ *		      because we have to keep track of the base relation, the
+ *		      indirect index relation itself, and the primary key index
+ *		      relation.
+ * ----------------------------------------------------------------
+ */
+IndirectIndexScanState *
+ExecInitIndirectIndexScan(IndirectIndexScan *node, EState *estate, int eflags)
+{
+	IndirectIndexScanState *indexstate;
+	Relation	currentRelation;
+	bool		relistarget;
+	int			i;
+
+	/*
+	 * create state structure
+	 */
+	indexstate = makeNode(IndirectIndexScanState);
+	indexstate->ss.ps.plan = (Plan *) node;
+	indexstate->ss.ps.state = estate;
+
+	/*
+	 * Miscellaneous initialization
+	 *
+	 * create expression context for node
+	 */
+	ExecAssignExprContext(estate, &indexstate->ss.ps);
+
+	indexstate->ss.ps.ps_TupFromTlist = false;
+
+	/*
+	 * initialize child expressions
+	 */
+	indexstate->ss.ps.targetlist = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.targetlist,
+					 (PlanState *) indexstate);
+	indexstate->ss.ps.qual = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.qual,
+					 (PlanState *) indexstate);
+	indexstate->indexqual = (List *)
+		ExecInitExpr((Expr *) node->indexqual,
+					 (PlanState *) indexstate);
+
+	/*
+	 * tuple table initialization
+	 */
+	ExecInitResultTupleSlot(estate, &indexstate->ss.ps);
+	ExecInitScanTupleSlot(estate, &indexstate->ss);
+
+	/*
+	 * open the base relation and acquire appropriate lock on it.
+	 */
+	currentRelation = ExecOpenScanRelation(estate, node->scan.scanrelid, eflags);
+
+	indexstate->ss.ss_currentRelation = currentRelation;
+	indexstate->ss.ss_currentScanDesc = NULL;	/* no heap scan here */
+
+	/*
+	 * get the scan type from the relation descriptor.
+	 */
+	ExecAssignScanType(&indexstate->ss, RelationGetDescr(currentRelation));
+
+	/*
+	 * Initialize result tuple type and projection info.
+	 */
+	ExecAssignResultTypeFromTL(&indexstate->ss.ps);
+	ExecAssignScanProjectionInfo(&indexstate->ss);
+
+	/*
+	 * If we are just doing EXPLAIN (ie, aren't going to run the plan), stop
+	 * here.  This allows an index-advisor plugin to EXPLAIN a plan containing
+	 * references to nonexistent indexes.
+	 */
+	if (eflags & EXEC_FLAG_EXPLAIN_ONLY)
+		return indexstate;
+
+	/*
+	 * Open the index relations.
+	 *
+	 * If the parent table is one of the target relations of the query, then
+	 * InitPlan already opened and write-locked the indexes, so we can avoid
+	 * taking another lock here.  Otherwise we need normal reader's locks.
+	 */
+	relistarget = ExecRelationIsTargetRelation(estate, node->scan.scanrelid);
+	indexstate->iiss_IndRelationDesc =
+		index_open(node->indexid, relistarget ? NoLock : AccessShareLock);
+	indexstate->iiss_PKRelationDesc =
+		index_open(node->pkindexid, relistarget ? NoLock : AccessShareLock);
+
+	/*
+	 * Initialize index-specific scan state
+	 */
+	indexstate->iiss_HaveIndirectTuple = false;
+	indexstate->iiss_RuntimeKeysReady = false;
+	indexstate->iiss_RuntimeKeys = NULL;
+	indexstate->iiss_NumRuntimeKeys = 0;
+
+	/*
+	 * build the index scan keys from the index qualification
+	 */
+	ExecIndexBuildScanKeys((PlanState *) indexstate,
+						   indexstate->iiss_IndRelationDesc,
+						   node->indexqual,
+						   false,
+						   &indexstate->iiss_ScanKeys,
+						   &indexstate->iiss_NumScanKeys,
+						   &indexstate->iiss_RuntimeKeys,
+						   &indexstate->iiss_NumRuntimeKeys,
+						   NULL,	/* no ArrayKeys */
+						   NULL);
+
+	/*
+	 * any ORDER BY exprs have to be turned into scankeys in the same way
+	 */
+	Assert(indexstate->iiss_NumOrderByKeys == 0);	/* FIXME and test */
+	ExecIndexBuildScanKeys((PlanState *) indexstate,
+						   indexstate->iiss_IndRelationDesc,
+						   node->indexorderby,
+						   true,
+						   &indexstate->iiss_OrderByKeys,
+						   &indexstate->iiss_NumOrderByKeys,
+						   &indexstate->iiss_RuntimeKeys,
+						   &indexstate->iiss_NumRuntimeKeys,
+						   NULL,	/* no ArrayKeys */
+						   NULL);
+
+	/*
+	 * For the PK scan, initialize the equality func OIDs of each column's
+	 * datatype.
+	 */
+	indexstate->iiss_EqualFuncs = palloc(sizeof(Oid) *
+										 indexstate->iiss_PKRelationDesc->rd_index->indnatts);
+	for (i = 0; i < indexstate->iiss_PKRelationDesc->rd_index->indnatts; i++)
+	{
+		AttrNumber attnum;
+		Oid		opfamily;
+		Oid		datatype;
+		Oid		eq_op;
+		Oid		eq_proc;
+
+		attnum = indexstate->iiss_PKRelationDesc->rd_index->indkey.values[i];
+		datatype = currentRelation->rd_att->attrs[attnum - 1]->atttypid;
+		opfamily = indexstate->iiss_PKRelationDesc->rd_opfamily[i];
+		eq_op = get_opfamily_member(opfamily, datatype, datatype,
+									  BTEqualStrategyNumber);
+		if (!OidIsValid(eq_op))
+			elog(ERROR, "missing operator %d(%u,%u) in opfamily %u",
+				 BTEqualStrategyNumber, datatype, datatype, opfamily);
+		eq_proc = get_opcode(eq_op);
+		if (!OidIsValid(eq_proc))
+			elog(ERROR, "missing oprcode for operator %u", eq_op);
+		indexstate->iiss_EqualFuncs[i] = eq_proc;
+	}
+
+	/* XXX initialize sort support?  See nodeIndexscan.c */
+
+	/*
+	 * If we have runtime keys, we need an ExprContext to evaluate them. The
+	 * node's standard context won't do because we want to reset that context
+	 * for every tuple.  So, build another context just like the other one...
+	 * -tgl 7/11/00
+	 */
+	if (indexstate->iiss_NumRuntimeKeys != 0)
+	{
+		ExprContext *stdecontext = indexstate->ss.ps.ps_ExprContext;
+
+		ExecAssignExprContext(estate, &indexstate->ss.ps);
+		indexstate->iiss_RuntimeContext = indexstate->ss.ps.ps_ExprContext;
+		indexstate->ss.ps.ps_ExprContext = stdecontext;
+	}
+	else
+	{
+		indexstate->iiss_RuntimeContext = NULL;
+	}
+
+	/*
+	 * Initialize scan descriptors.
+	 */
+	indexstate->iiss_IndScanDesc =
+		index_beginscan(currentRelation,
+						indexstate->iiss_IndRelationDesc,
+						estate->es_snapshot,
+						indexstate->iiss_NumScanKeys,
+						indexstate->iiss_NumOrderByKeys);
+	indexstate->iiss_PKScanDesc =
+		index_beginscan(currentRelation,
+						indexstate->iiss_PKRelationDesc,
+						estate->es_snapshot,
+						indexstate->iiss_PKRelationDesc->rd_index->indnatts,
+						0);
+
+	/*
+	 * If no run-time keys to calculate, go ahead and pass the scankeys to the
+	 * index AM.
+	 */
+	if (indexstate->iiss_NumRuntimeKeys == 0)
+		index_rescan(indexstate->iiss_IndScanDesc,
+					 indexstate->iiss_ScanKeys,
+					 indexstate->iiss_NumScanKeys,
+					 indexstate->iiss_OrderByKeys,
+					 indexstate->iiss_NumOrderByKeys);
+
+	/*
+	 * all done.
+	 */
+	return indexstate;
+}
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index a954610..f6d8497 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -500,7 +500,8 @@ ExecInsert(ModifyTableState *mtstate,
 			/* insert index entries for tuple */
 			recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
 												 estate, true, &specConflict,
-												   arbiterIndexes);
+												   arbiterIndexes,
+												   NULL);
 
 			/* adjust the tuple's state accordingly */
 			if (!specConflict)
@@ -546,7 +547,8 @@ ExecInsert(ModifyTableState *mtstate,
 			if (resultRelInfo->ri_NumIndices > 0)
 				recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
 													   estate, false, NULL,
-													   arbiterIndexes);
+													   arbiterIndexes,
+													   NULL);
 		}
 	}
 
@@ -952,6 +954,7 @@ ExecUpdate(ItemPointer tupleid,
 	else
 	{
 		LockTupleMode lockmode;
+		Bitmapset  *unchangedAttrs = NULL;
 
 		/*
 		 * Constraints might reference the tableoid column, so initialize
@@ -995,7 +998,9 @@ lreplace:;
 							 estate->es_output_cid,
 							 estate->es_crosscheck_snapshot,
 							 true /* wait for commit */ ,
-							 &hufd, &lockmode);
+							 &hufd,
+							 &unchangedAttrs,
+							 &lockmode);
 		switch (result)
 		{
 			case HeapTupleSelfUpdated:
@@ -1085,7 +1090,8 @@ lreplace:;
 		 */
 		if (resultRelInfo->ri_NumIndices > 0 && !HeapTupleIsHeapOnly(tuple))
 			recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
-												   estate, false, NULL, NIL);
+												   estate, false, NULL, NIL,
+												   unchangedAttrs);
 	}
 
 	if (canSetTag)
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index d973225..c0b6651 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -437,6 +437,34 @@ _copyIndexScan(const IndexScan *from)
 }
 
 /*
+ * _copyIndirectIndexScan
+ */
+static IndirectIndexScan *
+_copyIndirectIndexScan(const IndirectIndexScan *from)
+{
+	IndirectIndexScan  *newnode = makeNode(IndirectIndexScan);
+
+	/*
+	 * copy node superclass fields
+	 */
+	CopyScanFields((const Scan *) from, (Scan *) newnode);
+
+	/*
+	 * copy remainder of node
+	 */
+	COPY_SCALAR_FIELD(indexid);
+	COPY_SCALAR_FIELD(pkindexid);
+	COPY_NODE_FIELD(indexqual);
+	COPY_NODE_FIELD(indexqualorig);
+	COPY_NODE_FIELD(indexorderby);
+	COPY_NODE_FIELD(indexorderbyorig);
+	COPY_NODE_FIELD(indexorderbyops);
+	COPY_SCALAR_FIELD(indexorderdir);
+
+	return newnode;
+}
+
+/*
  * _copyIndexOnlyScan
  */
 static IndexOnlyScan *
@@ -3158,6 +3186,7 @@ _copyIndexStmt(const IndexStmt *from)
 	COPY_SCALAR_FIELD(indexOid);
 	COPY_SCALAR_FIELD(oldNode);
 	COPY_SCALAR_FIELD(unique);
+	COPY_SCALAR_FIELD(isindirect);
 	COPY_SCALAR_FIELD(primary);
 	COPY_SCALAR_FIELD(isconstraint);
 	COPY_SCALAR_FIELD(deferrable);
@@ -4431,6 +4460,9 @@ copyObject(const void *from)
 		case T_IndexScan:
 			retval = _copyIndexScan(from);
 			break;
+		case T_IndirectIndexScan:
+			retval = _copyIndirectIndexScan(from);
+			break;
 		case T_IndexOnlyScan:
 			retval = _copyIndexOnlyScan(from);
 			break;
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index edc1797..a60add1 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -1273,6 +1273,7 @@ _equalIndexStmt(const IndexStmt *a, const IndexStmt *b)
 	COMPARE_SCALAR_FIELD(indexOid);
 	COMPARE_SCALAR_FIELD(oldNode);
 	COMPARE_SCALAR_FIELD(unique);
+	COMPARE_SCALAR_FIELD(isindirect);
 	COMPARE_SCALAR_FIELD(primary);
 	COMPARE_SCALAR_FIELD(isconstraint);
 	COMPARE_SCALAR_FIELD(deferrable);
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 7258c03..bbc5973 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -489,6 +489,23 @@ _outIndexScan(StringInfo str, const IndexScan *node)
 }
 
 static void
+_outIndirectIndexScan(StringInfo str, const IndirectIndexScan *node)
+{
+	WRITE_NODE_TYPE("INDIRECTINDEXSCAN");
+
+	_outScanInfo(str, (const Scan *) node);
+
+	WRITE_OID_FIELD(indexid);
+	WRITE_OID_FIELD(pkindexid);
+	WRITE_NODE_FIELD(indexqual);
+	WRITE_NODE_FIELD(indexqualorig);
+	WRITE_NODE_FIELD(indexorderby);
+	WRITE_NODE_FIELD(indexorderbyorig);
+	WRITE_NODE_FIELD(indexorderbyops);
+	WRITE_ENUM_FIELD(indexorderdir, ScanDirection);
+}
+
+static void
 _outIndexOnlyScan(StringInfo str, const IndexOnlyScan *node)
 {
 	WRITE_NODE_TYPE("INDEXONLYSCAN");
@@ -2451,6 +2468,7 @@ _outIndexStmt(StringInfo str, const IndexStmt *node)
 	WRITE_OID_FIELD(indexOid);
 	WRITE_OID_FIELD(oldNode);
 	WRITE_BOOL_FIELD(unique);
+	WRITE_BOOL_FIELD(isindirect);
 	WRITE_BOOL_FIELD(primary);
 	WRITE_BOOL_FIELD(isconstraint);
 	WRITE_BOOL_FIELD(deferrable);
@@ -3389,6 +3407,9 @@ outNode(StringInfo str, const void *obj)
 			case T_IndexScan:
 				_outIndexScan(str, obj);
 				break;
+			case T_IndirectIndexScan:
+				_outIndirectIndexScan(str, obj);
+				break;
 			case T_IndexOnlyScan:
 				_outIndexOnlyScan(str, obj);
 				break;
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index d608530..a290008 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -1671,6 +1671,28 @@ _readIndexScan(void)
 }
 
 /*
+ * _readIndirectIndexScan
+ */
+static IndirectIndexScan *
+_readIndirectIndexScan(void)
+{
+	READ_LOCALS(IndirectIndexScan);
+
+	ReadCommonScan(&local_node->scan);
+
+	READ_OID_FIELD(indexid);
+	READ_OID_FIELD(pkindexid);
+	READ_NODE_FIELD(indexqual);
+	READ_NODE_FIELD(indexqualorig);
+	READ_NODE_FIELD(indexorderby);
+	READ_NODE_FIELD(indexorderbyorig);
+	READ_NODE_FIELD(indexorderbyops);
+	READ_ENUM_FIELD(indexorderdir, ScanDirection);
+
+	READ_DONE();
+}
+
+/*
  * _readIndexOnlyScan
  */
 static IndexOnlyScan *
@@ -2465,6 +2487,8 @@ parseNodeString(void)
 		return_value = _readSampleScan();
 	else if (MATCH("INDEXSCAN", 9))
 		return_value = _readIndexScan();
+	else if (MATCH("INDIRECTINDEXSCAN", 17))
+		return_value = _readIndirectIndexScan();
 	else if (MATCH("INDEXONLYSCAN", 13))
 		return_value = _readIndexOnlyScan();
 	else if (MATCH("BITMAPINDEXSCAN", 15))
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
index 2952bfb..5ff3ebe 100644
--- a/src/backend/optimizer/path/indxpath.c
+++ b/src/backend/optimizer/path/indxpath.c
@@ -776,9 +776,10 @@ get_index_paths(PlannerInfo *root, RelOptInfo *rel,
 	 * and those we mustn't submit to add_path here.)
 	 *
 	 * Also, pick out the ones that are usable as bitmap scans.  For that, we
-	 * must discard indexes that don't support bitmap scans, and we also are
-	 * only interested in paths that have some selectivity; we should discard
-	 * anything that was generated solely for ordering purposes.
+	 * must discard indexes that don't support bitmap scans as well as
+	 * indirect indexes, and we also are only interested in paths that have
+	 * some selectivity; we should discard anything that was generated solely
+	 * for ordering purposes.
 	 */
 	foreach(lc, indexpaths)
 	{
@@ -788,6 +789,7 @@ get_index_paths(PlannerInfo *root, RelOptInfo *rel,
 			add_path(rel, (Path *) ipath);
 
 		if (index->amhasgetbitmap &&
+			!index->indirect &&
 			(ipath->path.pathkeys == NIL ||
 			 ipath->indexselectivity < 1.0))
 			*bitindexpaths = lappend(*bitindexpaths, ipath);
@@ -800,6 +802,7 @@ get_index_paths(PlannerInfo *root, RelOptInfo *rel,
 	 */
 	if (skip_nonnative_saop)
 	{
+		Assert(!index->indirect);	/* what to do here? */
 		indexpaths = build_index_paths(root, rel,
 									   index, clauses,
 									   false,
@@ -1119,6 +1122,10 @@ build_paths_for_OR(PlannerInfo *root, RelOptInfo *rel,
 		if (!index->amhasgetbitmap)
 			continue;
 
+		/* Ignore indirect indexes too */
+		if (index->indirect)
+			continue;
+
 		/*
 		 * Ignore partial indexes that do not match the query.  If a partial
 		 * index is marked predOK then we know it's OK.  Otherwise, we have to
@@ -1798,6 +1805,10 @@ check_index_only(RelOptInfo *rel, IndexOptInfo *index)
 	if (!enable_indexonlyscan)
 		return false;
 
+	/* Can't use indirect indexes for index-only scans */
+	if (index->indirect)
+		return false;
+
 	/*
 	 * Check that all needed attributes of the relation are available from the
 	 * index.
